"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useAsync = (fn, args) => {
    const [state, set] = react_1.useState({
        loading: true,
    });
    const memoized = react_1.useCallback(fn, args);
    react_1.useEffect(() => {
        let mounted = true;
        set({
            loading: true,
        });
        const promise = memoized();
        promise
            .then(value => {
            if (mounted) {
                set({
                    loading: false,
                    value,
                });
            }
        }, error => {
            if (mounted) {
                set({
                    loading: false,
                    error,
                });
            }
        });
        return () => {
            mounted = false;
        };
    }, [memoized]);
    return state;
};
exports.default = useAsync;
