"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const useGetSet_1 = require("./useGetSet");
const react_1 = require("react");
const useCounter = (initialValue = 0) => {
    const [get, set] = useGetSet_1.default(initialValue);
    const inc = react_1.useCallback((delta = 1) => set(get() + delta), []);
    const dec = react_1.useCallback((delta = 1) => inc(-delta), []);
    const reset = react_1.useCallback((value = initialValue) => {
        initialValue = value;
        set(value);
    }, []);
    const actions = {
        inc,
        dec,
        get,
        set,
        reset,
    };
    return [get(), actions];
};
exports.default = useCounter;
