"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useDebounce = (fn, ms = 0, args = []) => {
    react_1.useEffect(() => {
        let handle = setTimeout(fn.bind(null, args), ms);
        return () => {
            // if args change then clear timeout
            clearTimeout(handle);
        };
    }, args);
};
exports.default = useDebounce;
