"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useUpdate_1 = require("./useUpdate");
const useGetSet = (initialValue) => {
    let state = react_1.useRef(initialValue);
    const update = useUpdate_1.default();
    const get = react_1.useCallback(() => state.current, []);
    const set = react_1.useCallback((value) => {
        state.current = value;
        update();
    }, []);
    return [get, set];
};
exports.default = useGetSet;
