"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
// kudos: https://usehooks.com/
const useHoverDirty = (ref) => {
    if (process.env.NODE_ENV !== 'production') {
        if ((typeof ref !== 'object') || (typeof ref.current === 'undefined')) {
            throw new TypeError('useHoverDirty expects a single ref argument.');
        }
    }
    const [value, setValue] = react_1.useState(false);
    react_1.useEffect(() => {
        const onMouseOver = () => setValue(true);
        const onMouseOut = () => setValue(false);
        if (ref && ref.current) {
            ref.current.addEventListener('mouseover', onMouseOver);
            ref.current.addEventListener('mouseout', onMouseOut);
        }
        return () => {
            if (ref && ref.current) {
                ref.current.removeEventListener('mouseover', onMouseOver);
                ref.current.removeEventListener('mouseout', onMouseOut);
            }
        };
    }, []);
    return value;
};
exports.default = useHoverDirty;
