"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const util_1 = require("./util");
const noop = () => { };
const useMediaDevices = () => {
    const [state, setState] = react_1.useState({});
    react_1.useEffect(() => {
        let mounted = true;
        const onChange = () => {
            navigator.mediaDevices.enumerateDevices()
                .then((devices) => {
                if (mounted) {
                    setState({
                        devices: devices.map(({ deviceId, groupId, kind, label }) => ({ deviceId, groupId, kind, label }))
                    });
                }
            })
                .catch(noop);
        };
        util_1.on(navigator.mediaDevices, 'devicechange', onChange);
        onChange();
        return () => {
            mounted = false;
            util_1.off(navigator.mediaDevices, 'devicechange', onChange);
        };
    }, [0]);
    return state;
};
exports.default = useMediaDevices;
