"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rebound_1 = require("rebound");
const react_1 = require("react");
const useSpring = (targetValue = 0, tension = 50, friction = 3) => {
    const [spring, setSpring] = react_1.useState(null);
    const [value, setValue] = react_1.useState(targetValue);
    react_1.useEffect(() => {
        const listener = {
            onSpringUpdate: (spring) => {
                const value = spring.getCurrentValue();
                setValue(value);
            }
        };
        if (!spring) {
            const newSpring = (new rebound_1.SpringSystem()).createSpring(tension, friction);
            newSpring.setCurrentValue(targetValue);
            setSpring(newSpring);
            newSpring.addListener(listener);
            return;
        }
        return () => {
            spring.removeListener(listener);
            setSpring(null);
        };
    }, [tension, friction]);
    react_1.useEffect(() => {
        if (spring) {
            spring.setEndValue(targetValue);
        }
    }, [targetValue]);
    return value;
};
exports.default = useSpring;
