"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useTimeout = (ms = 0) => {
    const [ready, setReady] = react_1.useState(false);
    react_1.useEffect(() => {
        let timer = setTimeout(() => {
            setReady(true);
        }, ms);
        return () => {
            clearTimeout(timer);
        };
    }, [ms]);
    return ready;
};
exports.default = useTimeout;
