"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useToggle = state => {
    const [value, setValue] = react_1.useState(state);
    const toggle = react_1.useCallback((nextValue) => {
        if (typeof nextValue !== 'undefined') {
            setValue(!!nextValue);
            return;
        }
        setValue(value => !value);
    }, [setValue]);
    return [value, toggle];
};
exports.default = useToggle;
